<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
<h:head>
    <title>ZTH-final</title>
    <style type="text/css">
        body {
            font-family: sans-serif;
            font-size: 16px;
            color: #404040;
        }

        .errorPanel {
            color: #A00000;
            background-color: #FFD0D0;
            border: 1px solid #FFA0A0;
            border-radius: 4px;
            text-align: center;
            padding: 8px;
            margin: 8px 8px 24px;
            font-weight: bold;
        }

        .infoPanel {
            color: #00A000;
            background-color: #D0FFD0;
            border: 1px solid #A0FFA0;
            border-radius: 4px;
            text-align: center;
            padding: 8px;
            margin: 8px 8px 24px;
            font-weight: bold;
        }

        input[type='text'], input[type='password'] {
            width: 100%;
            height: 32px;
            color: #101010;
            font-weight: bold;
            font-size: 16px;
        }

        input[type='submit'], input[type='button'] {
            height: 32px;
            font-weight: bold;
            background-color: #FAFAFA;
            border: 1px solid #F0F0F0;
            color: #707070;
            font-size: 16px;
        }

        input[type='submit']:hover, input[type='button']:hover {
            background-color: #F0F0F0;
            border: 1px solid #EAEAEA;
            color: #6A6A6A;
        }

        .redButton {
            background-color: #FFEAEA !important;
            border: 1px solid #FAD0D0 !important;
            color: #905050 !important;
        }

        .redButton:hover {
            background-color: #FAE0E0 !important;
            border: 1px solid #F0CACA !important;
            color: #854545 !important;
        }

        .taskForm {
            margin: 4px;
            border: 1px solid #F0F0F0;
            border-radius: 4px;
            background-color: #FCFCFC;
            padding: 18px;
            color: #505050;
        }

        .customHr {
            border-top: 1px solid #F0F0F0;
            margin-top: 4px;
            margin-bottom: 4px;
        }

        .rightIt * {
            float: right;
        }

        .rightIt:after {
            content: '';
            display: block;
            clear: both;
        }

        .accountsTable {
            border: 1px solid #C0C0C0;
            padding: 0;
            background-color: #FFFFFF;
            border-collapse: collapse;
            font-size: 18px;
            border-radius: 4px;
        }

        .accountsTable th {
            font-weight: bold;
            border-bottom: 2px solid #F0F0F0;
            background-color: #FAFAFA;
            padding: 8px;
        }

        .accountsTable td {
            border-bottom: 1px solid #E0E0E0;
            padding: 8px;
        }

        .accountsTable .rightCellWithLeftBorder {
            text-align: right;
            border-left: 1px solid #E0E0E0;
        }

        .accountsTable .leftCellWithLeftBorder {
            text-align: left;
            border-left: 1px solid #E0E0E0;
        }

        .accountsTable .centerCell {
            text-align: center;
        }

        .accountsTable .centerCellWithBothBorder {
            text-align: center;
            border-left: 1px solid #E0E0E0;
            border-right: 1px solid #E0E0E0;
        }

        .accountsTable .rightCell {
            text-align: right;
        }

    </style>
</h:head>
<body>

<h:panelGroup rendered="#{not empty indexBean.error}">
    <div class="errorPanel">
        <h:outputText value="#{indexBean.errorAndClear}"/>
    </div>
</h:panelGroup>

<h:panelGroup rendered="#{not empty indexBean.info}">
    <div class="infoPanel">
        <h:outputText value="#{indexBean.infoAndClear}"/>
    </div>
</h:panelGroup>

<h:form>
    <span style="margin-right: 32px; font-size: 18px">
        Welcome, <h:outputText value="#{loginBean.realName}" style="font-weight: bold"/><h:outputText value="(admin)"
                                                                                                      rendered="#{loginBean.admin}"/>!
    </span>
    <div class="rightIt" style="display: inline">
        <h:commandButton class="redButton" value="Logout" action="#{loginBean.logout()}"/>
        <h:commandButton value="Refresh" action="#{indexBean.refresh()}"/>
    </div>
    <div class="customHr" style="margin-bottom: 16px"/>

    <div class="taskForm">

        <div>
            <div style="float: left; display: inline; margin-right: 24px;">
                <h1>Request transaction</h1>

                <div class="taskForm" style="width: 300px">
                    <h:outputLabel for="sourceAccId" value="Source account ID"/>
                    <h:inputText id="sourceAccId" binding="#{sourceAccId}"/>

                    <h:outputLabel for="destAccId" value="Destination account ID"/>
                    <h:inputText id="destAccId" binding="#{destAccId}"/>

                    <h:outputLabel for="transAmount" value="Amount"/>
                    <h:inputText id="transAmount" binding="#{transAmount}"/>

                    <h:outputLabel for="comment" value="Comment"/>
                    <h:inputText id="comment" binding="#{comment}"/>

                    <div class="customHr" style="margin-bottom: 16px"/>

                    <div class="rightIt">
                        <h:commandButton value="Send request"
                                         action="#{tranactionBean.sendTransactionRequest(sourceAccId.value, destAccId.value, transAmount.value, comment.value)}"/>
                    </div>
                </div>
            </div>
            
            <div style="float: left; display: inline; margin-right: 24px;">
                <h1>TopUp (admin)</h1>

                <div class="taskForm" style="width: 300px">
                    <h:outputLabel for="topupAccountId" value="Account ID to topUp"/>
                    <h:inputText id="topupAccountId" binding="#{topupAccountId}"/>

                    <h:outputLabel for="topupAmount" value="Amount"/>
                    <h:inputText id="topupAmount" binding="#{topupAmount}"/>

                    <div class="customHr" style="margin-bottom: 16px"/>

                    <div class="rightIt">
                        <h:commandButton value="TopUp"
                                         action="#{accountBean.topUp(topupAccountId.value, topupAmount.value)}"/>
                    </div>
                </div>
            </div>

            <div style="float: left; display: inline; margin-right: 24px;">
                <h1>Accounts</h1>
                <table class="accountsTable">
                    <tr>
                        <th class="rightCell">AccID</th>
                        <th class="leftCellWithLeftBorder">Account name</th>
                        <th class="rightCellWithLeftBorder">Balance</th>
                        <th class="rightCellWithLeftBorder"></th>
                    </tr>
                    <ui:repeat value="#{accountBean.accounts}" var="account">
                        <tr>
                            <td style="min-width: 50px" class="rightCell"><h:outputText value="${account.id}"/></td>
                            <td style="min-width: 300px" class="leftCellWithLeftBorder"><h:outputText
                                    value="${account.name}"/></td>
                            <td style="min-width: 150px" class="rightCellWithLeftBorder"><h:outputText
                                    value="${account.balance}"/></td>
                            <td class="rightCellWithLeftBorder">
                                <h:commandButton value="Export" action="#{tranactionBean.export(account)}"/>
                            </td>
                        </tr>
                    </ui:repeat>
                </table>
            </div>
            
            <div style="clear: both"></div>
        </div>

        <h1>Transactions</h1>
        <table class="accountsTable">
            <tr>
                <th class="rightCell">TrID</th>
                <th class="rightCellWithLeftBorder">Amount</th>
                <th class="rightCellWithLeftBorder">Source account</th>
                <th></th>
                <th>Destination account</th>
                <th class="centerCellWithBothBorder">Status</th>
                <th class="centerCell">Request time</th>
                <th class="centerCell">Finish time</th>
                <th class="leftCellWithLeftBorder">Comment</th>
                <th class="leftCellWithLeftBorder">Error</th>
            </tr>

            <ui:repeat value="#{tranactionBean.last10Transactions}" var="trans">
                <tr>
                    <td style="min-width: 50px" class="rightCell"><h:outputText value="${trans.id}"/></td>
                    <td style="min-width: 100px" class="rightCellWithLeftBorder"><h:outputText value="${trans.amount}"/>
                    </td>
                    <td style="min-width: 100px" class="rightCellWithLeftBorder"><h:outputText
                            value="${trans.sourceAccount.name} [${trans.sourceAccount.id}]"/></td>
                    <td style="font-size: 32px">⟶</td>
                    <td style="min-width: 100px"><h:outputText
                            value="[${trans.destinationAccount.id}] ${trans.destinationAccount.name}"/></td>
                    <td style="min-width: 60px" class="centerCellWithBothBorder">
                        <h:outputText value="${trans.status.label()}" rendered="#{tranactionBean.isPending(trans)}"
                                      style="font-weight: bold; color: #AFA040"/>
                        <h:outputText value="${trans.status.label()}"
                                      rendered="#{not tranactionBean.isPending(trans)}"/>
                    </td>
                    <td style="font-size: 12px; min-width: 100px" class="centerCell"><h:outputText
                            value="#{trans.requested}">
                        <f:convertDateTime pattern="yyyy-MM-dd HH:mm:ss"/>
                    </h:outputText></td>
                    <td style="font-size: 12px; min-width: 100px" class="centerCell"><h:outputText
                            value="#{trans.finished}">
                        <f:convertDateTime pattern="yyyy-MM-dd HH:mm:ss"/>
                    </h:outputText></td>
                    <td style="font-size: 12px; font-style: italic; min-width: 100px" class="leftCellWithLeftBorder">
                        <h:outputText value="${trans.comment}"/></td>
                    <td style="font-size: 12px; color: #A00000; font-weight: bold; min-width: 200px"
                        class="leftCellWithLeftBorder"><h:outputText value="${trans.errorMessage}"/></td>
                </tr>
            </ui:repeat>
        </table>
        
    </div>
</h:form>

</body>
</html>
